/*
 * Copyright 2005-2010 the original author or authors.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wamblee.system.graph;

/**
 * Represents an application-independent edge of a graph. Applications might
 * choose to implement the Edge interface directly.
 * 
 * @author Erik Brakkee
 */
public class DefaultEdge implements Edge {
    private Node from;

    private Node to;

    /**
     * Creates a new DefaultEdge object.
     * 
     */
    public DefaultEdge(Node aFrom, Node aTo) {
        from = aFrom;
        to = aTo;
    }

    @Override
    public Node getFrom() {
        return from;
    }

    @Override
    public Node getTo() {
        return to;
    }

    @Override
    public String toString() {
        return "Edge(" + from.getName() + ", " + to.getName() + ")";
    }
}
